/*
 * jreversi.java
 *
 * Created on 29 de julio de 2005, 14:20
 *
 */

//package jreversi.pkg;

import javax.swing.*;
import java.awt.*;
import java.util.*;

public class jreversi implements Runnable {
    
    public static final long T_TEST = 100;
    public static final long T_PAUSE = 1000;
    
    private boolean gameFinished = false;
    private ReversiAI AI;
    
    private ReversiGUI gui;
    Thread t;
    
    /** Creates a new instance of jreversi */
    public jreversi() {
        AI = new ReversiAI();
        
        try {
            SwingUtilities.invokeAndWait(new Runnable() {
                public void run() {
                    gui = new ReversiGUI(AI);
                    AI.setGui(gui);
                }
            });
        } catch (Exception e){System.out.println(e);}
        
        t = new Thread(this);
        t.start();
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new jreversi();
    }
    
    /*
     * main thread
     */
    public void run() {
        Point move;
        byte row,col,turn;
        
        gui.setNewGameStarted(false);
        
        for(;;){
            // wait for new game request
            
            while (!gui.isNewGameStarted()){
                try {
                    Thread.sleep(T_TEST);
                } catch(InterruptedException ie) {}
            }
            gameFinished = false;
            gui.newGame();
            gui.setNewGameStarted(false);
            
            
            // an entire game
            while((!gui.isNewGameStarted())&&(!gameFinished)){
                
               
                // mirar el turno
                if (!AI.canMakeMove()){
                    //One is not able to change the turn
                    changeTurn();
                    if (!AI.canMakeMove()){
                        gui.finish(); // end of the game
                        gameFinished = true;
                        break;
                    }
                }
                
                // segun el turno elegir entre leer el humano o la mquina(minimax)
                if ((AI.getTurn() == ReversiAI.WHITE)||(!AI.isSinglePlayer())){
                    // parte humano
                    while(((move =  AI.getHumanMove()) == null)&&(!gui.isNewGameStarted())){
                        try {
                            Thread.sleep(T_TEST);
                        } catch(InterruptedException ie) {}
                    }
                    AI.setHumanMove(null);
                }else{
                    // parte maquina
                    move = AI.suggest();
                    try {
                        Thread.sleep(getPauseTime(AI.getPlys()));
                    } catch (InterruptedException ie) {}
                    gui.setProgress(100);
                }

                if(gui.isNewGameStarted()){
                    break;
                }
                
                row = (byte)move.x;
                col = (byte)move.y;
                if (AI.isValidMove(row,col)) {
                    
                    doMove(row,col,AI.update(row,col));
                    changeTurn();
                }else if ((AI.getTurn() == ReversiAI.BLACK)&&(AI.isSinglePlayer())){
                    // AI cannot find a valid move
                    changeTurn();
                }
            }
        }
    }
    
    private long getPauseTime(byte plys){
        switch (plys){
            case 1:
                return (long)(1.5*T_PAUSE);
            case 2:
                return (long)(1.5*T_PAUSE);
            case 3:
                return (long)(1.5*T_PAUSE);
            case 4:
                return (T_PAUSE);
            case 5:
                return (long)(T_PAUSE);
            case 6:
                return (long)(0.25*T_PAUSE);
            default:    
                return 0;
       }
    }
    
    private void doMove(int row, int col, LinkedHashSet s){
        final Point p = new Point(row,col);
        final LinkedHashSet takes = s;
        try {
            SwingUtilities.invokeAndWait(new Runnable() {
                public void run(){
                    gui.doMove(p.x,p.y,takes);
                }
            });
        } catch (Exception e){System.out.println(e);}
    }
    private void changeTurn() {
        AI.changeTurn();
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                gui.changeTurn(AI.getTurn());
            }
        });
    }
    
    private String strTurn(int t) {
        switch (t) {
            case 0:
                return "empty";
            case 1:
                return "white";
            case 2:
                return "black";
            default:
                System.out.println(" TURNO NO VALIDO !!!");
                return "MAL TURNO";
        }
    }
    
}
