/*
 * jreversi.java
 *
 * Created on 29 de julio de 2005, 14:20
 *
 */

import javax.swing.*;
import java.awt.*;
import java.util.*;

public class jreversi implements Runnable {
    
    public static final long T_TEST = 100;
    public static final long T_PAUSE = 1500;
    private boolean gameFinished = false;
    private ReversiAI AI;
    private ReversiGUI gui;
    Thread t;
    
    /** Creates a new instance of jreversi */
    public jreversi() {
        AI = new ReversiAI();
        
        try {
            SwingUtilities.invokeAndWait(new Runnable() {
                public void run() {
                    gui = new ReversiGUI(AI);
                    AI.setGui(gui);                }
            });
        } catch (Exception e){System.out.println(e);}
        
        t = new Thread(this);
        t.start();
    }
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new jreversi();
    }
    
    /*
     * main thread
     */
    public void run() {
        Point move;
        byte row,col,turn;
        
        gui.setNewGameStarted(false);
        
        for(;;){ 
            // wait for new game request
            
            while (!gui.isNewGameStarted()){
                try {
                    Thread.sleep(T_TEST);
                } catch(InterruptedException ie) {}
            }
            gameFinished = false;
            gui.newGame();
            gui.setNewGameStarted(false);
            
            
            // an entire game
            while((!gui.isNewGameStarted())&&(!gameFinished)){
                if (!AI.canMakeMove()){
                    changeTurn();
                }
                
                if ((AI.getTurn() == GameField.WHITE)||(!AI.isSinglePlayer())) {
                    while (((move =  AI.getHumanMove()) == null) && (!gui.isNewGameStarted())) {
                        try {
                            Thread.sleep(T_TEST);
                        } catch(InterruptedException ie) {}
                    }
                    AI.setHumanMove(null);
                } else {
                    move = AI.suggest();
                    try {
                        Thread.sleep(T_PAUSE);
                    } catch (InterruptedException ie) {}
                    gui.setProgress(100);
                }
                
                if(gui.isNewGameStarted()){
                    break;
                }
                
                row = (byte)move.x;
                col = (byte)move.y;
                if (AI.isValidMove(row,col)) {
                    AI.update(row,col);
                    doMove(row,col);
                    changeTurn();
                } else if ((AI.getTurn() == GameField.BLACK)&&(AI.isSinglePlayer())) {
                    // AI cannot find a valid move
                    changeTurn();
                }

                if (AI.getTree().expandir(AI.getTurn()) == GameField.EMPTY) {
                        gui.finish(); // end of the game
                        gameFinished = true;
                }
            }
        }
    }

    private void doMove(int row, int col){
        final Point p = new Point(row,col);
        try {
            SwingUtilities.invokeAndWait(new Runnable() {
                public void run(){
                    gui.doMove(p.x,p.y);
                }
            });
        } catch (Exception e){System.out.println(e);}
    }
    private void changeTurn() {
        AI.changeTurn();
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                gui.changeTurn(AI.getTurn());
            }
        });    
    }

}
